Module jdk.jlink
Package jdk.tools.jlink.builder

## Class DefaultImageBuilder

- java.lang.Object
- - jdk.tools.jlink.builder.DefaultImageBuilder

All Implemented Interfaces:
  ImageBuilder

    public class DefaultImageBuilder
    extends Object
    implements ImageBuilder

Default Image Builder. This builder creates the default runtime image layout.

### Constructor Summary

Constructors
Constructor and Description
`DefaultImageBuilder(boolean genBom, Path root)` Default image builder constructor.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`ExecutableImage` `getExecutableImage()` Gets the executable image that is generated.
`static ExecutableImage` `getExecutableImage(Path root)`
`DataOutputStream` `getJImageOutputStream()` The OutputStream to store the jimage file.
`protected void` `prepareApplicationFiles(Pool imageContent, Set<String> modules)` Generates launcher scripts.
`void` `storeFiles(Pool files, String bom)` Store the external files.
`void` `storeFiles(Pool files, String bom, Properties release)` Store the external files.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DefaultImageBuilder

    public DefaultImageBuilder(boolean genBom,
                               Path root)
                        throws IOException

Default image builder constructor.

Parameters:
  `genBom` - true, generates a bom file.
  `root` - The image root directory.
Throws:
  `IOException`

### Method Detail

#### storeFiles

    public void storeFiles(Pool files,
                           String bom,
                           Properties release)

Description copied from interface: `ImageBuilder`
Store the external files.

Specified by:
  `storeFiles` in interface `ImageBuilder`
Parameters:
  `files` - Pool of module content.
  `bom` - The options used to build the image file.
  `release` - the release properties

#### storeFiles

    public void storeFiles(Pool files,
                           String bom)

Description copied from interface: `ImageBuilder`
Store the external files.

Specified by:
  `storeFiles` in interface `ImageBuilder`
Parameters:
  `files` - Pool of module content.
  `bom` - The options used to build the image file.

#### prepareApplicationFiles

    protected void prepareApplicationFiles(Pool imageContent,
                                           Set<String> modules)
                                    throws IOException

Generates launcher scripts.

Parameters:
  `imageContent` - The image content.
  `modules` - The set of modules that the runtime image contains.
Throws:
  `IOException`

#### getJImageOutputStream

    public DataOutputStream getJImageOutputStream()

Description copied from interface: `ImageBuilder`
The OutputStream to store the jimage file.

Specified by:
  `getJImageOutputStream` in interface `ImageBuilder`
Returns:
  The output stream

#### getExecutableImage

    public ExecutableImage getExecutableImage()

Description copied from interface: `ImageBuilder`
Gets the executable image that is generated.

Specified by:
  `getExecutableImage` in interface `ImageBuilder`
Returns:
  The executable image.

#### getExecutableImage

    public static ExecutableImage getExecutableImage(Path root)